/*
DATETIME.C
bcc datetime.c
bcc -W -ewdatetim.exe datetime.c

100,000 iter		21/2A,2C	msec/call	1A/0	msec/call	DOS/BIOS
DATETIME:
DOS					 455		 .125		111		.030			4
WfW 3.11			2239		 .615		 85		.023		   26
Chicago				 982		 .270		 78		.021           12
WDATETIM:
WfW 3.11			4192		1.152		725		.199			5
Chicago				2110		 .580		855     .235			2

Note that Chicago much less overhead than WfW 3.11
But for 21/2A,2C still about twice plain DOS
On the other hand, for 1A/0, both WfW and Chicago better than DOS
Because not pass down to BIOS at all?
Was this true back in Windows 3.0?  Would make nice TEST1A demo if so.
Note disparity between DOS and BIOS times
Need to do Win32 example too
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <time.h>

typedef unsigned long DWORD;

main(int argc, char *argv[])
{
	DWORD iter = (argc < 2) ? 10000 : atol(argv[1]);
	DWORD i;
	clock_t t1, t2;
	DWORD elapsed;
	
	t1 = clock();
	for (i=0; i<iter; i++) {
		_asm mov ah, 2ah
		_asm int 21h
		_asm mov ah, 2ch
		_asm int 21h
		}
	t2 = clock();
	elapsed = t2 - t1;
	printf("INT 21h AH=2Ah, 2Ch\n");
	printf("Iterations:%lu, Elapsed: %lu\n", iter, elapsed);
	printf("%f millisec/call\n",
		(elapsed * (1000.0 / CLOCKS_PER_SEC)) / (iter * 2.0));
	
	t1 = clock();
	for (i=0; i<iter; i++) {
		_asm mov ah, 0
		_asm int 1Ah
		_asm mov ah, 0
		_asm int 1Ah
		}
	t2 = clock();
	elapsed = t2 - t1;
	printf("INT 1Ah AH=0, 0\n");
	printf("Iterations:%lu, Elapsed: %lu\n", iter, elapsed);
	printf("%f millisec/call\n",
		(elapsed * (1000.0 / CLOCKS_PER_SEC)) / (iter * 2.0));
}
