/* 
DPMITEST.C
bcc -I..\include -L..\lib dpmitest.c unauthwd.lib
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include "dpmish.h"
#include "prot.h"

typedef unsigned short WORD;
typedef WORD (far *FUNCPTR)(void);

void print_regs(void)
{
    static DWORD real_cs = 0, real_ds = 0;
    struct SREGS s;
    segread(&s);
    printf("CS=%04Xh DS=%04Xh\n", s.cs, s.ds);
    if (! (real_cs && real_ds)) // real mode
    {
        real_cs = s.cs; real_ds = s.ds;
    }
    else
    {
        DWORD cs_base, cs_limit, ds_base, ds_limit;
        cs_base = GetSelectorBase(s.cs);
        cs_limit = GetSelectorLimit(s.cs);
        ds_base = GetSelectorBase(s.ds);
        ds_limit = GetSelectorLimit(s.ds);
        printf("CS base=%08lX limit=%08lX\n", cs_base, cs_limit);
        printf("DS base=%08lX limit=%08lX\n", ds_base, ds_limit);
        if ((cs_base != (real_cs << 4L)) ||
            (ds_base != (real_ds << 4L)))
            printf("Something wrong!!\n");
    }
}

void fail(const char *s, ...)           { puts(s); _dos_exit(1); }
#pragma argsused
int real_main(int argc, char *argv[])   { print_regs(); return 0; }
#pragma argsused
int pmode_main(int argc, char *argv[])
{
    print_regs(); 
#ifdef DO_CTRL_C_TEST
    while (! ctrl_c_hit)
        printf("!");
    printf("\nDone!\n");
#endif

    return 0;
}

