/* DUMP.C -- a real-mode memory dumper */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>

#ifndef MK_FP
#define MK_FP(seg,ofs) \
    ((void far *)(((unsigned long)(seg) << 16) | (ofs)))
#endif

void dump(unsigned char far *fp, unsigned bytes, 
    char *mask, unsigned long addr, int width)
{
    unsigned char far *p;
    unsigned i, j, c;
    
    for (i=0; i<bytes; i += width)
    {
        c = ((bytes-i) > width) ? width : bytes-i;
        printf(mask, addr+i);
        printf(" | ");
        for (j=c, p=fp+i; j--; p++)
            printf("%02X ", *p);
        for (j=width-c; j--; )  // pad out on last line
            printf("   ");
        printf("| ");
        for (j=c, p=fp+i; j--; p++)
            putchar( isprint(*p) ? *p : '.' );
        putchar('\n');
    }
}

#ifdef STANDALONE
void fail(char *s) { puts(s); exit(1); }

main(int argc, char *argv[])
{
	unsigned char far *fp;
	unsigned bytes, seg, ofs;
	if (argc < 2 || (! strchr(argv[1], ':')))
		fail("usage: dump [seg:ofs] <bytes>");
	sscanf(argv[1], "%04X:%04X", &seg, &ofs);
	fp = (unsigned char far *) MK_FP(seg, ofs);
	bytes = (argc < 3) ? 128 : atoi(argv[2]);
	dump(fp, bytes, "%Fp", (unsigned long) fp, 16);
	return 0;
}
#endif
