/* 
FAULTHKS.C 
Call VMM Get_Fault_Hook_Addrs to get V86, PM, and VMM fault hook addrs
Andrew Schulman, February 1994
*/

#include <stdlib.h>
#include <stdio.h>
#include "prot.h"
#include "vxdcalls.h"

void fail(const char *s, ...)           { puts(s); exit(1); }

int GetFaultHookAddrs(int intno, DWORD *pv86, DWORD *ppm, DWORD *pvmm)
{
	VxDParams p;
	if (intno == 2)
	{
		p.CallNum = Get_NMI_Handler_Addr;
		VxDCall(&p);
		*pvmm = p.OutESI;
		*pv86 = 0;
		*ppm = 0;
		return 1;
	}
	else
	{
		p.CallNum = Get_Fault_Hook_Addrs;
		p.InEAX = intno;
		VxDCall(&p);
		if (p.OutEFLAGS & CARRYFLAG)
			return 0;
		else
		{
			*pv86 = p.OutEDX;
			*ppm = p.OutESI;
			*pvmm = p.OutEDI;
			return 1;
		}
	}
}

main()
{
	DWORD v86, pm, vmm;
	int i;
	printf("INT\t\tV86\t\tPM\t\tVMM\n");
	printf("---\t\t--------\t--------\t--------\n");
	for (i=0; i<=0xFF; i++)
		if (GetFaultHookAddrs(i, &v86, &pm, &vmm) != 0)
			if (v86 || pm || vmm)
				printf("%02X\t\t%08lX\t%08lX\t%08lX\n",
					i, v86, pm, vmm);
	return 0;
}
