/* filelib.c -- routines used by NE executable utilities */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <dos.h>
#include "filelib.h"

extern void fail_perror(void);
extern void fail(char *s);

extern unsigned long start_newexe;

/* read at offset from NE */
int ne_read(int f, void *p, unsigned long ne_offset, unsigned short bytes)
{
	int retval;
	if (lseek(f, start_newexe + ne_offset, SEEK_SET) == -1)
		fail_perror();
	if ((retval = read(f, p, bytes)) == -1)
		fail_perror();
	return retval;
}

/* read at offset from beginning of file */
int exe_read(int f, void *p, unsigned long exe_offset, unsigned short bytes)
{
	int retval;
    if (lseek(f, exe_offset, SEEK_SET) == -1)
		fail_perror();
	if ((retval = read(f, p, bytes)) == -1)
		fail_perror();
	return retval;
}

void *allocate(size_t x, size_t y)
{
	void *p;
	if (! x) x = 1;
	if (! y) y = 1;
	if (((long) x * (long) y) > 0xFFFFUL)
		fail("internal error");
	if ((p = calloc(x, y)) == 0)
		fail("insufficient memory");
	return p;
}

/* in place, turn counted strings into null-terminated strings */
void count2null(char *s, int len)
{
	unsigned char *s2; 
	int i;
	for (i=0, s2=s; i<len; )
	{
		int len2 = *s2;	// get string length
		*s2 = '\0';		// replace with NULL
		if (len2 + (s2 - s) > len)
			return;
		len2++;
		i += len2;
		s2 += len2;
	}
	*s2 = '\0';			// get last one -- table must include room for it
}
