/* FTAB.C */

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

#ifndef MK_FP
#define MK_FP(seg, ofs) \
    ((void far *) (((DWORD) (seg) << 16) | (ofs)))
#endif      

void fail(const char *s) { puts(s); exit(1); }

main(int argc, char *argv[])
{
    char *prefix;
    void far *tab;
    BYTE far *btab;
    WORD far *wtab;
    DWORD far *dtab;
    WORD seg, ofs;
    int num_func, size, i;

    if (argc < 4)
        fail("usage: ftab <seg:ofs> <num_func | ?> [prefix] [size]");

    sscanf(argv[1], "%04X:%04X", &seg, &ofs);
    tab = (void far *) MK_FP(seg, ofs);
    
    if (argv[2][0] == '?')
    {
        num_func = *((BYTE far *) tab);     /* first BYTE is #func */
        tab = ((BYTE far *) tab + 1);       /* then array of WORDs */
    }
    else
        sscanf(argv[2], "%04X", &num_func);
    
    prefix = (argc > 3) ? argv[3] : "func";
    size = (argc > 4) ? atoi(argv[4]) : 2;  /* default to WORD table */

    switch (size)
    {
        case 1:
            for (i=0, btab=(BYTE far *)tab; i<num_func; i++, btab++)
                printf("%02X\t%s_%02X\n",
                    *btab, prefix, i);
            break;
        case 2:
            for (i=0, wtab=(WORD far *)tab; i<num_func; i++, wtab++)
                printf("%04X:%04X\t%s_%02X\n",
                    seg, *wtab, prefix, i);
            break;
        case 4:
            for (i=0, dtab=(DWORD far *)tab; i<num_func; i++, dtab++)
                printf("%Fp\t%s_%02X\n",
                    *dtab, prefix, i);
            break;
        default:
            fail("size only 1 (byte), 2 (word), 4 (dword)");
    }

    return 0;
}
