/*
INTSERV.C
Toy Win16 Server for FWORD.C (Win32->Win16 Thunk demo)
Win32 app can call INT 21h, INT 2Fh, or INT 31h via INTSERV

bcc -W -3 -B intserv.c

from Schulman, Unauthorized Windows, 1994
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#define NOGDI
#include "windows.h"

static char dummy;	// just something to take seg of

// static vars:  only one caller at a time
#define SERVER(calls,intno) { \
	static char stack[1024]; \
	static unsigned stack_seg; \
	static unsigned prev_seg; \
	static unsigned long prev_ofs; \
	static unsigned prev_ds; \
	_asm { \
		push ax; \
		push bx; \
		mov ax, ds; \
		mov bx, seg dummy; \
		mov ds, bx; \
		mov stack_seg, bx; \
		mov prev_ds, ax; \
		pop bx; \
		pop ax; \
		mov prev_seg, ss; \
		mov dword ptr prev_ofs, esp; \
		mov ss, stack_seg; \
		mov sp, offset stack; \
		add sp, 512; \
	} \
	calls++; \
	_asm { \
		int intno; \
		mov ss, prev_seg; \
		mov esp, dword ptr prev_ofs; \
		mov ds, prev_ds; \
		db 66h; \
		retf; \
	} \
}

unsigned long calls21 = 0;
unsigned long calls2F = 0;
unsigned long calls31 = 0;

void server21(void) { SERVER(calls21, 0x21); }
void server2F(void) { SERVER(calls2F, 0x2F); }
void server31(void) { SERVER(calls31, 0x31); }

int PASCAL WinMain(HANDLE hInstance, HANDLE hprev21Instance,
    LPSTR lpszCmdLine, int nCmdShow)
{
	char buf[120];
	int len;
	
	len = sprintf(buf, "INT 21h server @ %Fp\n", (void far *) server21);
	len += sprintf(buf+len, "INT 2Fh server @ %Fp\n", (void far *) server2F);
	len += sprintf(buf+len, "INT 31h server @ %Fp", (void far *) server31);
	MessageBox(0, buf, "INTSERV", MB_OK);
	
	// servers are active until click MB_OK above
	
	len = sprintf(buf, "%lu calls to INT 21h server\n", calls21);
	len += sprintf(buf+len, "%lu calls to INT 2Fh server\n", calls2F);
	len += sprintf(buf+len, "%lu calls to INT 31h server", calls31);
	MessageBox(0, buf, "INTSERV", MB_OK);
	return 0;
}
		
