comment %
INTVECT.ASM
Sample VxD that handles two INT 21h functions entirely in protected mode
INT 21h function 25h: Set Interrupt Vector
INT 21h function 35h: Get Interrupt Vector

from Schulman, Unauthorized Windows, 1994

masm5 -p -w2 intvect.asm
link386 intvect.obj,intvect.386,,,intvect.def
addhdr intvect.386

INTVECT.DEF:

LIBRARY	 INTVECT
DESCRIPTION 'INT 21h Functions 0Eh, 19h Handler'
EXETYPE	 DEV386
SEGMENTS
	_LTEXT PRELOAD NONDISCARDABLE
	_LDATA PRELOAD NONDISCARDABLE
	_ITEXT CLASS 'ICODE' DISCARDABLE
	_IDATA CLASS 'ICODE' DISCARDABLE
	_TEXT  CLASS 'PCODE' NONDISCARDABLE
	_DATA  CLASS 'PCODE' NONDISCARDABLE
EXPORTS		INTVECT_DDB  @1
%

.386p

INCLUDE VMM.INC
INCLUDE V86MMGR.INC

IFSMgr_Init_Order	EQU	0A0011000h	;; found by running VXDSHOW IFSMGR.386

Declare_Virtual_Device INTVECT, 1, 0, \
    Control_Proc, \
    Undefined_Device_ID, \
    IFSMgr_Init_Order+10000H, , ,\

VxD_CODE_SEG

BeginProc   Int21V86
    movzx   eax, [ebp.Client_AH]
    cmp     al, 25h
    je      short Do_SetVect
    cmp     al, 35h
    je      short Do_GetVect
    stc                                     ;; chain to previous handler
    ret

Do_SetVect:
    movzx   eax, [ebp.Client_AL]   			;; interrupt number
    movzx   edx, [ebp.Client_DS] 			;; get interrupt handler 
    shl     edx, 16							;;    from caller's DS:DX
    mov   	dx, [ebp.Client_DX]
	mov		ecx, [ebx.CB_High_Linear]
    mov     dword ptr [ecx + (eax * 4)], edx;; shove into IVT[eax]
    clc                                     ;; done -- don't chain!
    ret

Do_GetVect:
    movzx   eax, [ebp.Client_AL]   			;; interrupt number
	mov		ecx, [ebx.CB_High_Linear]
    mov     edx, dword ptr [ecx + (eax * 4)];; get handler from IVT[eax]
    mov     [ebp.Client_BX], dx    			;; put into caller's ES:BX
    shr     edx, 16
    mov     [ebp.Client_ES], dx    
    clc                                     ;; done -- don't chain!
    ret
EndProc     Int21V86

VxD_CODE_ENDS

VxD_LOCKED_CODE_SEG

BeginProc   Control_Proc
    Control_Dispatch Device_Init, Do_Device_Init
    clc     
    ret
EndProc     Control_Proc

VxD_LOCKED_CODE_ENDS

VxD_ICODE_SEG

BeginProc   Do_Device_Init
	mov		eax, 21h
	mov		esi, offset32 Int21V86
	VMMcall	Hook_V86_Int_Chain
    ret
EndProc     Do_Device_Init

VxD_ICODE_ENDS

VXD_REAL_INIT_SEG

real_init proc near
    xor ax, ax
    xor bx, bx
    xor si, si
    xor edx, edx
    ret
real_init endp

VXD_REAL_INIT_ENDS

    END
