/* 
PMINTVEC.C
DPMI version: bcc -2 -DDPMI_APP pmintvec.c dpmish.obj ctrl_c.obj
Windows version: bcc -W pmintvec.c

Sample output:
INT 10    003B:0350
INT 13    003B:0320
INT 15    003B:0322
INT 1C    003B:0324
INT 1E    007B:0000
INT 21    003B:0386
INT 23    0097:0450
INT 25    003B:032E
INT 26    003B:0330
INT 2A    003B:0326
INT 2F    003B:0352
INT 31    003B:020E
INT 33    003B:031C
INT 41    003B:0218
INT 46    003B:0218
INT 4B    003B:0334
INT 5C    003B:0328
INT 67    003B:0346
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#ifdef DPMI_APP
#include "dpmish.h"
#endif

typedef void (interrupt far *INTVECT)();

INTVECT my_dos_getvect(int intno)
{
	_asm mov ah, 35h
	_asm mov al, byte ptr intno
	_asm int 21h
	_asm mov ax, bx
	_asm mov dx, es
	// retval in DX:AX
}

INTVECT _dpmi_get_pmode_vect(int intno)
{
	INTVECT iv;
	_asm mov ax, 0204h
	_asm mov bl, byte ptr intno
	_asm int 31h
	_asm jc error
	_asm mov word ptr iv+2, cx
	_asm mov word ptr iv, dx
	return iv;
error:
	return (INTVECT) 0;
}

unsigned get_callback_seg(void)
{
	_asm mov ax, 1684h	// get PM API for any VxD
	_asm mov bx, 5
	_asm int 2fh
	_asm mov ax, es		// just want segment
}

#ifdef DPMI_APP
#define PUT(s)				  { fputs(s, stderr); fputs("\n", stderr); }

void fail(const char *s, ...) { PUT(s); _dos_exit(1); }

int real_main(int argc, char *argv[])   { return 0; }

int pmode_main(int argc, char *argv[])
#else
int main(int argc, char *argv[])
#endif
{
	void far *fp, far *fp2;
	int i;
	unsigned seg = get_callback_seg();
	for (i=0; i<0xff; i++)
	{
		if ((fp = my_dos_getvect(i)) != 0)
		{
			/*
				Generally, almost all entries look like:
					INT 00    003B:0000
					INT 01    003B:0002
					INT 02    003B:0004
				So filter these out.
			*/
			if ((FP_SEG(fp) != seg) || (FP_OFF(fp) != (i * 2)))
				printf("INT %02X    %Fp\n", i, fp);
		}
		/* Sometimes in Win app, DPMI 31/0204 != pmode DOS 21/35 */
		if ((fp2 = _dpmi_get_pmode_vect(i)) != 0)
			if (fp2 != fp)
				printf("INT %02X    %Fp (DPMI; DOS = %Fp)\n", 
					i, fp2, fp);
	}
	return 0;
}



