/* VXD86API.C */

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

typedef DWORD (far *FUNCPTR)(void);

// call the Windows "Get Device Entry Point Address" function
// Interrupt 2Fh Function 1684h
FUNCPTR GetDeviceAPI(WORD vxd_id)
{
	_asm {
		push di
		push es
		xor di, di
		mov es, di
		mov ax, 1684h
		mov bx, vxd_id
		int 2fh
		mov ax, di
		mov dx, es
		pop es
		pop di
		}
    // return value in DX:AX
}

int IsEnhancedMode(void)
{
	_asm {
		mov ax, 1600h
		int 2fh
		test al, 7fh
		jz no
		}
	return 1;
no: return 0;
}

void fail(const char *s, ...) { puts(s); exit(1); }

int main()
{
    WORD i;
    FUNCPTR fp;
	
	if (! IsEnhancedMode())
		fail("This program requires Windows Enhanced mode");
    
    puts("Virtual-8086 (V86) VxD APIs:");
    // for each possible device id, see if there's an API
    for (i=0; i<0xffff; i++)
        if (fp = GetDeviceAPI(i))
            printf("%04Xh   %Fp   %0lX   %02X\n", 
				i,				// VxD ID
				fp,				// V86 entry point
				((DWORD) FP_SEG(fp) << 4) + FP_OFF(fp),	// linear addr
				*((BYTE far *) fp));					// byte (ARPL)
	return 0;
}

