/*
VXDTEST.C -- VxD test rig

To do:
Need table of function names, numbers
Change syntax so specify input registers (EBX= BX= etc.)
Support VxDPushCall too!
Implement dump (can't spawn PROTDUMP because nested DOSX problem!)
Let user specify output registers with ?EBX ?EAX
*/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include "dpmish.h"
#include "prot.h"
#include "vxdcalls.h"

void fail(const char *s, ...)           { puts(s); _dos_exit(1); }

#pragma argsused
int real_main(int argc, char *argv[])   { return 0; }

void do_dump(char *buf);
void do_vxdcall(char *buf);
void do_usage(char *buf);

#pragma argsused
int pmode_main(int argc, char *argv[])
{
	char buf[80];
	int c;
	for (;;)
	{
		printf("> ");
		gets(buf);
		c = toupper(buf[0]);
		switch (c)
		{
			case 'Q': goto done; break;
			case 'D': do_dump(buf); break;
			case '?': do_usage(buf); break;
			default: do_vxdcall(buf); break;	// check if hex number!!
		}
	}
done:	
	printf("done\n");
	return 0;
}

void do_dump(char *buf)
{
	printf("DUMP not supported yet\n");
}

void do_usage(char *buf)
{
	printf("Usage: CallNum EAX EBX ECX EDX ESI EDI\n");
}

void do_vxdcall(char *buf)
{
	VxDParams p;	// later do push params too
	sscanf(buf, "%lX %lX %lX %lX %lX %lX %lX", 
		&p.CallNum, &p.InEAX, &p.InEBX, &p.InECX, &p.InEDX,
		&p.InESI, &p.InEDI);
	if (VxDCall(&p))
	{
		printf("EAX=%08lX EBX=%08lX ECX=%08lX EDX=%08lX\n",
			p.OutEAX, p.OutEBX, p.OutECX, p.OutEDX);
		printf("EBP=%08lX ESI=%08lX EDI=%08lX EFLAGS=%08lX\n",
			p.OutEBP, p.OutESI, p.OutEDI, p.OutEFLAGS);
	}
	else
		printf("Call failed!\n");
}

