/*
WALKWIN.C
Windows app walks window list, show Win16 aspects of all windows

from Schulman, Unauthorized Windows, 1994
*/

#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include "windows.h"
#include "toolhelp.h"
#include "winio.h"

void print_hwnd(HWND hwnd, int level)
{
	char taskname[9];
	char wndproc_owner[9];
	GLOBALENTRY *pge;
	HANDLE htask, htaskq;
	void far *wndproc;
	char *wndtext, *classname;
	int flag32;
	
	int i;
	
	if (! (wndtext = (char *) malloc(128)))
		fail("Insufficient memory");
	if (! (classname = (char *) malloc(128)))
		fail("Insufficient memory");
	
	htask = GetWindowTask(hwnd);
	GetWindowText(hwnd, wndtext, 128);
	wndproc = GetClassLong(hwnd, GCL_WNDPROC);
	GetClassName(hwnd, classname, 128);
	flag32 = *((WORD far *) MK_FP(htask, 0x16)) & 0x10;
	htaskq = *((WORD far *) MK_FP(htask, 0x20));
	_fmemcpy(taskname, MK_FP(htask, 0xF2), 8);
	taskname[8] = '\0';
	
	wndproc_owner[0] = '\0';
	if (! (pge = (GLOBALENTRY *) malloc(sizeof(GLOBALENTRY))))
		fail("Insufficient memory");
	pge->dwSize = sizeof(GLOBALENTRY);
	if (GlobalEntryHandle(pge, FP_SEG(wndproc)))
	{
		MODULEENTRY *pme;
		if (! (pme = (MODULEENTRY *) malloc(sizeof(MODULEENTRY))))
			fail("Insufficient memory");
		pme->dwSize = sizeof(MODULEENTRY);
		if (ModuleFindHandle(pme, pge->hOwner))
			strcpy(wndproc_owner, pme->szModule);
		free(pme);
	}
	free(pge);
	
	for (i=0; i<level; i++) 
		printf("  ");
	printf("%s %s %04Xh  %04Xh  %04Xh  %Fp (%s) \'%s\'  ",
		flag32 ? "32" : "16",
		taskname, hwnd, htask, htaskq, 
		wndproc, wndproc_owner, classname);
	if (wndtext && *wndtext) 
		printf("\"%s\"", wndtext);
	printf("\n");
	
	free(classname);
	free(wndtext);
}

void walkwin(HWND hwnd, int level)
{
	if (hwnd == 0)
		return;
	hwnd = GetWindow(hwnd, GW_HWNDFIRST);
	while (hwnd)
	{
		print_hwnd(hwnd, level);
		walkwin(GetWindow(hwnd, GW_CHILD), level+1);
		hwnd = GetWindow(hwnd, GW_HWNDNEXT);
	}
	if (level == 0) printf("\n");
}
	
main(int argc, char *argv[])
{
	HWND hwnd;
	if (argc < 2) hwnd = GetWindow(GetDesktopWindow(), GW_CHILD);
	else sscanf(argv[1], "%04X", &hwnd);
	winio_setpaint(__hMainWnd, FALSE);
#if 1
	walkwin(hwnd, 0);
#else
	walkwin(GetWindow(GetDesktopWindow(), GW_CHILD), 0);
#endif
	winio_setpaint(__hMainWnd, TRUE);
	return 0;
}
